#!/bin/bash 

BD_NAME="/sopenvpn/sopenvpn.db"
TABLE_NAME="MAIN" 
IP_MASTER_TABLE="IP_MASTER"
USER_MASTER_TABLE="USER_MASTER"
METHODS="DISCONNECT"
LOG_FILE="/etc/openvpn/openvpn-connection.log"

IP_INFO="${ifconfig_pool_remote_ip}"
USER_INFO="${common_name}"


DATE(){
	date "+%Y-%m-%d %H:%M:%S.%N"
}

SQLITE_INSERT(){

sqlite3 ${BD_NAME} <<EOF
INSERT OR IGNORE INTO ${IP_MASTER_TABLE} values('${IP_INFO}', NULL);
INSERT OR IGNORE INTO ${USER_MASTER_TABLE} values('${USER_INFO}', NULL);
INSERT OR IGNORE INTO ${TABLE_NAME} select ${IP_MASTER_TABLE}.B,${USER_MASTER_TABLE}.B from ${IP_MASTER_TABLE},${USER_MASTER_TABLE} WHERE ${USER_MASTER_TABLE}.A = '${USER_INFO}' and ${IP_MASTER_TABLE}.A = '${IP_INFO}';	
EOF


}

SQLITE_DELETE(){
sqlite3 ${BD_NAME} <<EOF
DELETE FROM ${TABLE_NAME} WHERE B = ( SELECT B FROM ${USER_MASTER_TABLE} where A = '${USER_INFO}' ) and A = ( SELECT B FROM ${IP_MASTER_TABLE} where A = '${IP_INFO}' );
EOF
	
}

WRITE_LOGS(){
	echo -ne "$(DATE) [${METHODS}] ${trusted_ip}:${trusted_port} ${IP_INFO} ${USER_INFO} ${bytes_sent} ${bytes_received}\n"	>> ${LOG_FILE}
	return;
}

MAIN(){
	
	[ "x${bytes_sent}" == "x" ] && METHODS="CONNECT"
	
	WRITE_LOGS
	[ "x${METHODS}" == "xCONNECT" ] && SQLITE_INSERT;	
	#[ "x${METHODS}" == "xDISCONNECT" ] && SQLITE_DELETE;
}

MAIN $*